#import "AppDelegate.h"
#import "UrlDownloaderOperation.h"


static NSString * OperationsChangedContext = @"OperationsChangedContext";

@implementation AppDelegate

- (void)applicationDidFinishLaunching:(NSNotification *)notification
{
    _queue = [[NSOperationQueue alloc] init];
    // Set to 1 to serialize operations. Comment out for parallel operations.
    // [_queue setMaxConcurrentOperationCount:1];
    
    [_queue addObserver:self
             forKeyPath:@"operations"
                options:0
                context:&OperationsChangedContext];
}

- (void)dealloc
{
    [_queue removeObserver:self forKeyPath:@"operations"];
    [_queue release];
    [super dealloc];
}

- (IBAction)start:(id)sender
{
    NSArray * urls = [NSArray arrayWithObjects:
                      @"http://www.apple.com/",
                      @"http://www.google.com/",
                      @"http://foo.invalid/",
                      nil];
    for (NSString * url in urls)
    {
        UrlDownloaderOperation * operation =
            [UrlDownloaderOperation urlDownloaderWithUrlString:url];
        [_queue addOperation:operation];
    }
}

- (void)observeValueForKeyPath:(NSString *)keyPath
                      ofObject:(id)object
                        change:(NSDictionary *)change
                       context:(void *)context
{
    if (context == &OperationsChangedContext)
    {
        NSLog(@"Queue size: %u", [[_queue operations] count]);
    }
    else
    {
        [super observeValueForKeyPath:keyPath
                             ofObject:object
                               change:change
                              context:context];
    }
}

@end
